<template>
	<div class="map">
		<q-img :src="mapSrc" v-if="mapSrc" @click="onMapClick"></q-img>
		<div v-for="room in rooms" v-bind:key="room.id">
			<room-map
				class="room"
				:roomId="room.id"
				:mapHeightFactor="mapHeightFactor"
				:style="floorPlanComputedStyle(room)"
			/>
		</div>
		<q-resize-observer @resize="onResize" />
	</div>
</template>

<script>
	import fetchFn from "../js/fetch";
	import roomMap from "./roomMap";
	export default {
		name: "DepartmentMap",
		data() {
			return {
				APIURL: undefined,
				mapSrc: undefined,
				mapOriginalWidth: undefined,
				mapOriginalHeight: undefined,
				mapHeightFactor: 1,
				mapWidthFactor: 1
			};
		},
		components: {
			roomMap
		},
		props: {
			department: {
				type: Object,
				required: true
			},
			facilities: {
				type: Array,
				required: true
			},
			actions: {
				type: Array,
				required: true
			},
			rooms: {
				type: Array,
				required: true
			}
		},
		created() {
			if (screen.width < 1200) {
				this.screenTooSmall();
			}
			this.APIURL = fetchFn.getAPIURL();
			this.mapOriginalWidth = this.department.mapWidth;
			this.mapOriginalHeight = this.department.mapHeight;

			this.mapSrc = fetchFn.getAPIURL() + "/" + this.department.mapFileName;
		},
		methods: {
			floorPlanComputedStyle(room) {
				return {
					width: room.width * this.mapWidthFactor + "px",
					height: room.height * this.mapHeightFactor + +"px",
					left: room.x * this.mapWidthFactor + "px",
					top: room.y * this.mapHeightFactor + "px"
				};
			},
			onResize(size) {
				if (size.width < 1200) {
					this.screenTooSmall();
				}
				this.mapHeightFactor = size.height / this.mapOriginalHeight;
				this.mapWidthFactor = size.width / this.mapOriginalWidth;
			},
			onMapClick() {
				this.rooms.forEach(room => this.floorPlanComputedStyle(room));
			},
			screenTooSmall() {
				this.$fire({
					title: this.$i18n.t("error.error"),
					html: this.$i18n.t("error.screenWidth"),
					type: "error"
				});
				this.$q.cookies.set("departmentLayout", true, {
					expires: 365,
					path: "/"
				});
				this.$emit("screensize", screen.width);
			}
		},
		watch: {
			department() {
				this.mapSrc =
					fetchFn.getAPIURL() + "/" + this.department.mapFileName;
			}
		}
	};
</script>

<style scoped>
	.map {
		margin-top: 5px;
		position: relative;
		overflow: hidden;
		height: 100%;
	}
	.room {
		position: absolute;
	}
</style>
